# Contributing

When contributing to this repository, please first discuss the change you wish to make via an [issue](https://github.com/jackdomleo7/Cooltipz.css/issues) before making a change - any pull request submitted without being linked to a relevant issue will be questioned. Feel free to create a pull request to resolve an issue, fix a typo, make an improvement, update a dependency, etc. Please provide as much detail and as many resources that will back up why you made the change and stick to the issue template provided as much as possible.

When looking to contribute to Cooltipz.css, please first look at the [Cooltipz.css Kanban Board](https://github.com/jackdomleo7/Cooltipz.css/projects/4). Any issue sitting in the "To do (approved)" column is available to anyone to be picked up and worked on. _Do not pick up any issues in the "Backlog" column since these have not yet been approved to be added to the Cooltipz.css project._ Once you have found an issue you would like to work on, comment on issues asking if you can pick it up. Please do not ask to work on an issue that is assigned to someone else (you can see who is assigned to an issue by looking at the "assignee").

You cannot be assigned to more than one issue at the same time, unless you are an owner/collaborator or have had permission from an owner/collaborator. Please complete the issue you are working on before requesting to be assigned to another issue. This is to allow fair opportunity to those wanting to contribute. If you are assigned to an issue, but no longer want to be, just add a comment on the issue letting us know you want to be unassigned (no questions asked). You will automatically be unassigned from an issue after 3 months of inactivity.

Try not to include mass work into a single pull request. We'd prefer one pull request for every issue, so we have a clean history of changes.

This project is happy to take part in [Hacktoberfest](https://hacktoberfest.digitalocean.com) each year and is willing to help dedicated developers make contributions to qualify for their Hacktoberfest profile. If you would like your pull request to be included in Hacktoberfest, please add a comment to the "Other details" section in your pull request letting us know (only valid during the Hacktoberfest season and not during any other time of the year). We will manually add the `Hacktoberfest` tag to your pull request, unless we feel the pull request is spam, in which case we will mark the pull request as `spam` and the pull request will be closed meaning it will not qualify as a valid pull request for the Hacktoberfest event.

Please note we have a [code of conduct](./CODE_OF_CONDUCT.md), please follow it in all your interactions with the project.

## Pull Request Process

1. Ensure any install or build dependencies are removed before the end of the layer when doing a build.
2. All comments must be resolved before approval. All required workflows must pass before approval.
3. An owner/collaborator will merge the pull request once the pull request has been approved by an owner/collaborator and no further modifications are needed.
